;*_____________________________________________________________________________
;*
;*           Author: Terry Carmen 
;*       Released to the Public Domain.
;*_____________________________________________________________________________
;*
;*
;*     Program Name:   videomod.asm 
;*        $Revision$
;*            $Date$
;*
;*
;*
;* Revision History:
;*             $Log$
;*
;*_____________________________________________________________________________ 
;
;
;
;/* The following code will change the current video mode from your        */
;/* Clipper 5.x or Summer 87 program.                                      */
;/*                                                                        */
;/* This will allow you to set your display for any screen size your video */
;/* card and monitor support.                                              */
;/*                                                                        */
;/* From Clipper call it as videomode(n) where n is a decimal number       */
;/* representing the desired video mode.                                   */
;/*                                                                        */
;/* It will return .T. if the mode is supported by your card, and .F. if   */
;/* not.                                                                   */
;
;
;
;/*  !WARNING!                                                   */
;/*  !WARNING!                                                   */
;/*  !WARNING!                                                   */
;/*  !WARNING!                                                   */
;/*                                                              */
;/*  Setting your video card to a mode that the monitor doesn't  */
;/*  support may damage your monitor                             */
;/*                                                              */


; assemble with tasm videomod /mx /w2


public  videomode
        
extrn   __retl:far
extrn   __parni:far
extrn   __parinfo:far

dgroup  group   datasg
datasg  segment public  '_DATA'
   
   ; no data right now

datasg  ends


_prog	segment	'CODE'
        assume	cs:_prog,ds:dgroup,es:nothing

videomode    proc    far
             push bp
             mov bp, sp
             push ds
             push es
             push dx
             push cx
             push bx
             push ax

            mov ax, 0
            push ax
            call __parinfo
            add sp, 2
            cmp ax, 1                 ; 1 param?
            jne @@bye

            mov ax, 1
            push ax
            call __parinfo
            add sp, 2
            cmp ax, 2                   ; numeric?
            jne @@bye

            mov ax, 1
            push ax
            call __parni
            add sp, 2                   ; leaves video mode in al, and 0 in ah, 
                                        ; which is exactly what we need for the int 10h 
                                        ; set videomode function

           push ax                      ; so we can compare it 
           int 10h                      ; Try to set new video mode


            mov ah, 0Fh                 ; get the current videomode
            int 10h                     ; if the mode change was supported by the card, 
            pop bx                      ; the current mode will be the one we just set
            cmp al, bl                  ; if not, it will be whatever it was before

            jne @@badexit               ; bad mode - not supported by card

            mov ax, 1                   ; good mode - card can handle it
            jmp short @@bye

@@badexit:   mov ax, 0

@@bye:       push ax
             call __retl                ; return .T. or .F. 
             add sp, 2

             pop ax
             pop bx
             pop cx
             pop dx
             pop es
             pop ds
             pop bp
             ret
             
videomode    endp
_prog        ends
             end






